<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Graham Featherstone - Project 12</title>
    <link href="../../styles.css" rel="stylesheet" />
</head>

<body>
    <header>
        <div class="container">
            <div class="text-container">
                <h1>Graham Featherstone</h1>
                <p>Chemical Engineering Student | Teacher | Enthusiast</p>
            </div>
            <img src="../../Cropped2.jpg" width="200px">
        </div>
    </header>

    <section>
        <h1>Project 12</h1>
        <h2>
            Key Objectives
        </h2>
        <hl>
            <li>Input devices</li>
            <li>Further utilize KiCad</li>
            <li>Learn skills towards my final project</li>
        </hl>
    </section>

    <section>
        <h1> Idea</h1>
        <p>For my input devices, I was rather inspired by my personal health tracking that I typically accomplish by
            using my smart watch. When the teacher presented the idea that
            we could use the <a href="https://www.sparkfun.com/products/15219"> Sparkfun Pulse Oximiter and Heart Rate
                Sensor</a>, I jumped at the opportunity and was able to secure one of the boards for my project.
        </p>
        <div class="image-container">
            <img src="Project12Images/Capture1.jpg" style="width:500px">
        </div>
        <p>
            This 0.5 inch by 1 inch board is able to determine blood oxygen saturation and pulse rate through the use of
            transmitting and detecting light signals which are provided by the board.
            The design of the board was very strait forward as I was using this pre-fabricated input device to collect
            the data. I decided to use the Seeeded Xiao RP2040 for this project since I needed to be able
            to both send data to the sparkfun device, but I also needed to be able to easily READ data from the
            device...This was one of the limitations which reduced my interest in utilizing the ATtiny412 for this
            project... I hope that I can learn to
            both send and receive data from the ATtiny412. However, the RP2040 was a simple choice due to time
            constraints.
        </p>
        <div class="image-container">
            <img src="Project12Images/Capture2.JPG" style="width:500px">
            <img src="Project12Images/Capture3.JPG" style="width:500px">
        </div>
        <p> The board design was very simplistic as I simply wanted to be able to receive data from the pulse oximeter
            and display it on my Arduino IDE. For this case, I needed to connect the SDA and SCL inputs of both the
            RP2040 and the pulse oximiter since the devices
            utilizes I2C communication. I also needed to power the device using a 3.3V output from the RP2040 and a
            PWR_GND. In addition to these inputs, the pulse oximeter requires a RST pin, and MFIO pin to be connected to
            the microcontroller to reset functionality. More information can be found on the
            <a href="https://learn.sparkfun.com/tutorials/sparkfun-pulse-oximeter-and-heart-rate-monitor-hookup-guide">
                hookup guide</a> for the pulse oximeter. The real challenges for this project presented themselves when
            I finally arrived in the lab and realized that the chip that I had access to had been
            previously used and the setup of the board could be nothing like I had originally designed...
        </p>
        <div class="image-container">
            <img src="Project12Images/Capture6.jpg" style="width:500px">
        </div>
        <p>
            In my design, I had fabricated it so that the pulse oximeter could be nicely mounted vertically, and that it would be supported by the copper base plate. The pulse oximeter that I had received 
            had horizontal connectors soldered directly to the board...This presented a problem...
        </p>
        <p>
            My options....Re-design and resolder my board, re-book the milling machine, re-mill my board, and have it connect to the already soldered pins on the pulse oximiter....
        </p>
        <p>OR</p>
        <p>Desolder the current pins and solder my own...This option seemed to be the most simple...I was so wrong.</p>
        <p>I started desoldering the board...at first using the solder braid to remove the largest amount of the previous solder. This did not work since the previous user of the board had added the solder inside of the holes 
            which the solder braid could not access. This took a long time to figure out...and calm down... I wish I had the pulse sensor on me while I was doing this so that I could have monitored my own stress and frustration. 
            Once the solder braid failed, I tried to go to more drastic measures. I used a heat gun to try to melt the solder that is inside of the hole and remove the pins. This worked very well for a few of the pins, but some of them were
            stubborn (just like me), and refused to release my pulse oximeter.
        </p>
        <p> Although I did not take a picture after I finished desoldering the pulse oximeter, I did take a photo of it when I had already re-soldered my new pins so that it would work with my board.  </p>
        <div class="image-container">
            <img src="Project12Images/Capture8.jpg" style="width:500px">
        </div>
        <p> As you can see from the image above, the heat fun seared the chip as if it were a sirloin steak on a hot summer day. The heatgun also loosened the SDA rivet on the SparkFun board 
            which I tried to fix by adding additional solder to the pin...Now my board was milled, my pins were connected, it was time to populate the board entirely. </p>
            <div class="image-container">
                <img src="Project12Images/Capture9.jpg" style="width:500px">
                <img src="Project12Images/Capture10.jpg" style="width:500px">
            </div>
            <div class="image-container">
                <img src="Project12Images/Capture8.jpg" style="width:500px">
            </div>
            <p>
                Unfortunately the board (pictures above) did not function properly. In my original design, I had, in my haste, not connected the SDA of the RP2040 to the SDA of the pulse oximeter, nor the SCL of the RP2040 to the SCL of the pulse oximeter...
            </p>
            <p>
                So it was back to the drawing board anyways...Fate is a cruel mistress.
            </p>
            <p>
                I redesigned the board properly (as pictured above), and had a day of figuring out why the board was not milling properly. Although the track widths were set to 0.4 mm in Kicad, the machine was milling the tracks way to thin, or milling them so quickly that it was 
                shredding the board...
            </p>
            <div class="image-container">
                <img src="Project12Images/Capture5.jpg" style="width:500px">
                <img src="Project12Images/Capture7.jpg" style="width:500px">
            </div>
            <p> I had run into the issue of it milling the board to quickly and destroying the tread paths before...but never that it was milling the wrong thickness of tread paths...I solved this issue eventually...it was two variables </p>
            <p> One is that I need to individually specify the outline of the board EVERY TIME in CopperCad. Unfortunately, the autodetect feature of the program does not function for me. </p>
            <p> The second is that I need to set my Z-axis higher and let the drilling bit fall further to the surface. The SRM-20 was bottoming out on my design and was not able to correctly mill the treads.</p>
            <p> Milling the board...9 trials later..was successful. However, now I ran into another issue...I had soldered the pulse oximeter to my non-functioning board and now I needed to desolder it (again). Cue several hours later. </p>
            <p> Once the board was desoldered, it was quite damaged as the SDA pin was still missing the rivet and it was burned to a crisp. In this case, I decided to change my design to use female pin heads and to connect the pulse oximeter with jumper cables and it's inbuilt <a href="https://www.sparkfun.com/qwiic"> QUIIC</a> connection. This method worked!!!</p>
            <div class="image-container">
                <img src="Project12Images/Capture11.jpg" style="width:500px">
            </div>
            <p>It ain't pretty, but it works</p>
            <center>
                <video width="400" height="400" controls>
                    <source src="Project12Images/Video2.mp4" type="video/mp4">
                </video>
            </center>
            <center>
                <video width="400" height="400" controls>
                    <source src="Project12Images/Video3.mp4" type="video/mp4">
                </video>
            </center>
            <p> This project was exceedingly stressful for how simple it ended up being in the end. I did however learn a lot of lessons and I needed to troubleshoot a lot of these issues alone. But, I also appreciate the advice and help that I received when I became too stressed and also restarted the whole project. </p>
    </section>




</body>

</html>